# tipplektionen

Das Programm erstellt aus einem Wörterbuch Tipplektionen.

Dabei können verschiedene Optionen angegeben werden:
* Minmale / maximale Wortlänge
* Maximale Zeilenlänge
* Anzahl der auszugebenden Zeilen
* Vorgabe von Buchstaben, aus denen die Wörter bestehen dürfen
* Ausgabe auf Wunsch nur in Kleinbuchstaben

## Abhängigkeiten
Das Programm verwendet folgende Bibliotheken:
* Boost, Ver. >= 1.74
* ICU, Ver. >= 70

Außerdem wird unter `/usr/share/dict/ngerman` eine Datei mit infrage kommender Wörter erwartet. Unter Arch Linux kann man etwa das Paket *community/words* installieren, das u. a. diese liefert. Ansonsten kann auch die mitgelieferte Datei `ngerman` verwendet werden. Entweder kann sie an entsprechende Stelle kopiert oder der Pfad mittels `--dictfile` angegeben werden.

## Installation
Die Anwendung kann mittels `cmake` compiliert werden:
```
cmake -B build -S . -DCMAKE_BUILD_TYPE=Release
cmake --build build
```
Anschließend liegt im build-Verzeichnis die ausführbare Datei.

## Verwendung
Die Option `-h` listet alle Möglichkeiten auf:
```
Erlaubte Optionen:
  -h [ --help ]            Ausgabe der Hilfe
  -c [ --characters ] arg  Erlaubte Buchstaben
  -m [ --must-have ] arg   Buchstaben, die im Wort vorhanden sein *müssen* 
                           (nur in Verbindung mit --characters; Buchstaben 
                           müssen davon Subset sein.)
  --min-length arg         Minimale Wortlänge
  --max-length arg         Maximale Wortlänge
  --line-length arg        Maximale Zeilenlänge
  -n [ --num-lines ] arg   Anzahl Zeilen
  -d [ --dictfile ] arg    Pfad zur Wörterbuchdatei
  -l [ --lowercase ]       Ausgabe nur klein geschrieben
  -s [ --starts-capital ]  Wort muss mit einem Großbuchstaben beginnen
```